
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Integration_endpointsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const integration_endpoints = await db.integration_endpoints.create(
            {
                id: data.id || undefined,
        
        integration_type: data.integration_type
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        base_url: data.base_url
        ||
        null
            ,
            
        auth_type: data.auth_type
        ||
        null
            ,
            
        config_json: data.config_json
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
        last_success_at: data.last_success_at
        ||
        null
            ,
            
        last_failure_at: data.last_failure_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await integration_endpoints.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        

        return integration_endpoints;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const integration_endpointsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                integration_type: item.integration_type
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                base_url: item.base_url
            ||
            null
            ,
            
                auth_type: item.auth_type
            ||
            null
            ,
            
                config_json: item.config_json
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
                last_success_at: item.last_success_at
            ||
            null
            ,
            
                last_failure_at: item.last_failure_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const integration_endpoints = await db.integration_endpoints.bulkCreate(integration_endpointsData, { transaction });

        // For each item created, replace relation files
        

        return integration_endpoints;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const integration_endpoints = await db.integration_endpoints.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.integration_type !== undefined) updatePayload.integration_type = data.integration_type;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.base_url !== undefined) updatePayload.base_url = data.base_url;
        
        
        if (data.auth_type !== undefined) updatePayload.auth_type = data.auth_type;
        
        
        if (data.config_json !== undefined) updatePayload.config_json = data.config_json;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        if (data.last_success_at !== undefined) updatePayload.last_success_at = data.last_success_at;
        
        
        if (data.last_failure_at !== undefined) updatePayload.last_failure_at = data.last_failure_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await integration_endpoints.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await integration_endpoints.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        

        return integration_endpoints;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const integration_endpoints = await db.integration_endpoints.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of integration_endpoints) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of integration_endpoints) {
                await record.destroy({transaction});
            }
        });


        return integration_endpoints;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const integration_endpoints = await db.integration_endpoints.findByPk(id, options);

        await integration_endpoints.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await integration_endpoints.destroy({
            transaction
        });

        return integration_endpoints;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const integration_endpoints = await db.integration_endpoints.findOne(
            { where },
            { transaction },
        );

        if (!integration_endpoints) {
            return integration_endpoints;
        }

        const output = integration_endpoints.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await integration_endpoints.getOrganization({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'integration_endpoints',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.base_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'integration_endpoints',
                        'base_url',
                        filter.base_url,
                    ),
                };
            }
            
            if (filter.auth_type) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'integration_endpoints',
                        'auth_type',
                        filter.auth_type,
                    ),
                };
            }
            
            if (filter.config_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'integration_endpoints',
                        'config_json',
                        filter.config_json,
                    ),
                };
            }
            

            
            

            
            if (filter.last_success_atRange) {
                const [start, end] = filter.last_success_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_success_at: {
                    ...where.last_success_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_success_at: {
                    ...where.last_success_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_failure_atRange) {
                const [start, end] = filter.last_failure_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_failure_at: {
                    ...where.last_failure_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_failure_at: {
                    ...where.last_failure_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.integration_type) {
                where = {
                    ...where,
                integration_type: filter.integration_type,
            };
            }
            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.integration_endpoints.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'integration_endpoints',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.integration_endpoints.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

